{    var   : }
{ N, IERR, M, FE }
Unit MNP1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AIH1R_p, MNP12_p;

procedure MNP1R(var M :Integer; var N :Integer; var A :Array of Real;
                var B :Array of Real; var U :Array of Real;
                var P :Array of Real; FSTEP :Real; IPAR :Integer;
                var MAXK :Integer; XE :Real; var FE :Real;
                var KOUNT :Integer; var CO :Array of Real;
                var G :Array of Real; var I0 :Array of Integer;
                var IERR :Integer);

implementation

procedure MNP1R(var M :Integer; var N :Integer; var A :Array of Real;
                var B :Array of Real; var U :Array of Real;
                var P :Array of Real; FSTEP :Real; IPAR :Integer;
                var MAXK :Integer; XE :Real; var FE :Real;
                var KOUNT :Integer; var CO :Array of Real;
                var G :Array of Real; var I0 :Array of Integer;
                var IERR :Integer);
var
I,I1,IRM,IUP,IX,IXE,J,J1,K,KI,L,LI :Integer;
F,S,S1 :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190;
begin
AIH1R(U,CO,N,IERR);
if ( IERR =  65 ) 
 then goto _190;
IRM := N + 1;
IUP := IRM + 3*M + 8;
IX := IUP + M + 3;
IXE := IX + M;
K := IX - 1;
L := IXE - 1;
for I:=1 to M do
 begin
  KI := K + I;
  LI := L + I;
  U[KI-1] := 0.0;
  U[LI-1] := XE;
_10:
 end;
U[IX-3] := FSTEP;
U[IX-2] := IPAR;
U[IRM+0] := MAXK;
K := 0;
for I:=1 to M do
 begin
  for J:=1 to I do
   begin
    S := 0.0;
    for I1:=1 to N do
     begin
      S1 := 0.0;
      for J1:=1 to N do
       begin
        if ( I1 - J1 ) < 0
         then goto _20
         else if ( I1 - J1 ) > 0
               then goto _30
               else goto _30;
_20:
        L := I1 + J1*(J1 - 1) div 2;
        goto _40;
_30:
        L := J1 + I1*(I1 - 1) div 2;
_40:
        S1 := S1 + A[(I-1)+(J1-1)*M]*CO[L-1];
       end;
      S := S + A[(J-1)+(I1-1)*M]*S1;
_50:
     end;
    K := K + 1;
    G[K-1] := S/4.0;
_60:
   end;
_70:
 end;
for I:=1 to M do
 begin
  S := 0.0;
  for J:=1 to N do
   begin
    S1 := 0.0;
    for K:=1 to N do
     begin
      if ( J - K ) < 0
       then goto _80
       else if ( J - K ) > 0
             then goto _90
             else goto _90;
_80:
      L := J + K*(K - 1) div 2;
      goto _100;
_90:
      L := K + J*(J - 1) div 2;
_100:
      S1 := S1 + A[(I-1)+(K-1)*M]*CO[L-1];
     end;
    S := S + P[J-1]*S1;
_110:
   end;
  B[I-1] := B[I-1] + S/2.0;
_120:
 end;
MNP12(M,B,G,U[IX-1],U[IXE-1],F,FE,I0,U[IRM-1],U[IUP-1],IERR);
KOUNT := Trunc( U[IRM-1] );
MAXK := Trunc( U[IRM+0] );
K := IX - 1;
for I:=1 to N do
 begin
  S := 0.0;
  for J:=1 to M do
   begin
    S := S + A[(J-1)+(I-1)*M]*U[K+J-1];
_130:
   end;
  U[I-1] := P[I-1] + S;
_140:
 end;
for I:=1 to N do
 begin
  S := 0.0;
  for J:=1 to N do
   begin
    if ( I - J ) < 0
     then goto _150
     else if ( I - J ) > 0
           then goto _160
           else goto _160;
_150:
    L := I + J*(J - 1) div 2;
    goto _170;
_160:
    L := J + I*(I - 1) div 2;
_170:
    S := S + CO[L-1]*U[J-1];
   end;
  P[I-1] := S*(-0.5);
  if ( P[I-1] <  0.0 ) 
   then P[I-1] := 0.0;
_180:
 end;
_190:
end;

end.
