{    var   : }
{ N, F, FE }
Unit MNP12_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNP13_p, MNP14_p, MNP16_p;

procedure MNP12(var N :Integer; var H :Array of Real;
                var G :Array of Real; var X :Array of Real;
                var XE :Array of Real; var F :Real; var FE :Real;
                var I0 :Array of Integer; var RM :Array of Real;
                var UP :Array of Real; var W :Integer);

implementation

procedure MNP12(var N :Integer; var H :Array of Real;
                var G :Array of Real; var X :Array of Real;
                var XE :Array of Real; var F :Real; var FE :Real;
                var I0 :Array of Integer; var RM :Array of Real;
                var UP :Array of Real; var W :Integer);
var
I,M,N3 :Integer;
label
_10,_20,_30,_40;
begin
W := 0;
for I:=1 to N do
 begin
  I0[I-1] := 1;
_10:
 end;
M := Trunc( RM[1] );
RM[1] := RM[1]*(-1.0);
MNP13(N,X,XE,F,FE,G,H,RM,UP);
_20:
for I:=1 to N do
 begin
  if ( I0[I-1] =  0 ) 
   then goto _30;
  MNP14(I,N,X,XE,F,FE,G,H,I0,RM,UP);
  if ( RM[1] >=  0 ) 
   then W := 4;
  if ( W =  4 ) 
   then goto _40;
_30:
 end;
MNP16(N,XE,FE,RM,UP,I0,W);
if ( W =  0 ) 
 then goto _20;
N3 := 4 + 3*N;
if ( RM[N3+0] <>  N ) 
 then goto _20;
W := 0;
_40:
RM[1] := M + RM[1];
end;

end.
