{    var   : }
{ N, F, FE }
Unit MNP14_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNP11_p, MNP15_p;

procedure MNP14(I :Integer; var N :Integer; var X :Array of Real;
                var XE :Array of Real; var F :Real; var FE :Real;
                var G :Array of Real; var H :Array of Real;
                var I0 :Array of Integer; var RM :Array of Real;
                var UP :Array of Real);

implementation

procedure MNP14(I :Integer; var N :Integer; var X :Array of Real;
                var XE :Array of Real; var F :Real; var FE :Real;
                var G :Array of Real; var H :Array of Real;
                var I0 :Array of Integer; var RM :Array of Real;
                var UP :Array of Real);
var
IN1,IN2,L,N1,N2,N3 :Integer;
A,B,FT2,RE1,XF :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90;
begin
N1 := 4 + N;
N2 := 4 + 2*N;
N3 := 4 + 3*N;
XF := X[I-1];
A := 0.0;
B := 1.E+15;
IN2 := I + N2;
RM[N3+2] := RM[IN2-1];
if ( UP[N+2] =  0 ) 
 then RM[N3+2] := UP[N+1];
RE1 := -RM[N3+2]*RM[N3+2];
L := 0;
IN1 := I + N1;
X[I-1] := XF + Sign(RM[N3+2],RM[IN1-1]);
_10:
if ( X[I-1] <  A ) 
 then goto _20;
if ( X[I-1] >  B ) 
 then goto _20;
MNP11(N,H,X,G,FT2);
RM[N3+3] := FT2;
RM[1] := RM[1] + 1.0;
if ( RM[1] >=  0 ) 
 then goto _90;
if ( Abs(FT2-F) <=  FE ) 
 then goto _70;
if ( FT2 - F <=  RE1 ) 
 then goto _30;
_20:
if ( L =  1 ) 
 then goto _40;
L := 1;
X[I-1] := XF - Sign(RM[N3+2],RM[IN1-1]);
goto _10;
_30:
MNP15(I,N,X,XE,F,FE,G,H,A,B,I0,RM,UP,XF);
goto _80;
_40:
RM[N3+2] := RM[N3+2]/2.0;
X[I-1] := XF;
if ( UP[N+2] =  1 ) 
 then goto _50;
RM[N3+1] := RM[N3+1] + 1.0;
if ( RM[N3+1] <  N - RM[N3+0] ) 
 then goto _80;
UP[N+1] := RM[N3+2];
RM[N3+1] := 0;
RM[IN2-1] := RM[IN2-1]/2.0;
if ( RM[N3+2] >  XE[I-1] ) 
 then goto _80;
RM[N3+0] := N;
RM[0] := RM[0] + 1;
goto _90;
_50:
RM[IN2-1] := RM[N3+2];
if ( RM[N3+2] <=  XE[I-1] ) 
 then goto _70;
_60:
goto _80;
_70:
X[I-1] := XF;
I0[I-1] := 0;
RM[N3+0] := RM[N3+0] + 1;
if ( UP[N3+2] =  1 ) 
 then RM[IN2-1] := RM[N3+2];
_80:
RM[0] := RM[0] + 1;
_90:
end;

end.
