{    var   : }
{ N }
Unit MNP15_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNP11_p;

procedure MNP15(I :Integer; var N :Integer; var X :Array of Real;
                var XE :Array of Real; var F :Real; FE :Real;
                var G :Array of Real; var H :Array of Real; A :Real;
                B :Real; var I0 :Array of Integer;
                var RM :Array of Real; var UP :Array of Real;
                XF :Real);

implementation

procedure MNP15(I :Integer; var N :Integer; var X :Array of Real;
                var XE :Array of Real; var F :Real; FE :Real;
                var G :Array of Real; var H :Array of Real; A :Real;
                B :Real; var I0 :Array of Integer;
                var RM :Array of Real; var UP :Array of Real;
                XF :Real);
var
IN1,N1,N2,N3 :Integer;
label
_10,_20,_30,_40;
begin
N1 := 4 + N;
N2 := 4 + 2*N;
N3 := 4 + 3*N;
IN1 := I + N1;
if ( X[I-1] >  A + 2.0*XE[I-1] ) 
 then goto _10;
X[I-1] := A;
RM[IN1-1] := 1.0;
goto _20;
_10:
if ( X[I-1] <  B ) 
 then goto _30;
X[I-1] := B;
RM[IN1-1] := -1.0;
_20:
MNP11(N,H,X,G,F);
I0[I-1] := 0;
RM[N3+0] := RM[N3+0] + 1;
RM[1] := RM[1] + 1;
goto _40;
_30:
RM[IN1-1] := Sign(1.0,X[I-1] - XF);
F := RM[N3+3];
_40:
RM[N3+1] := 0;
end;

end.
